%{
#include <math.h>
#define max_table_size 100
%}

Unsigned_int [0-9]+
Signed_int ("+"|"-")[0-9]+
Decimal ("+"|"-")?[0-9]+"."[0-9]+
Scientific ("+"|"-")?[0-9]+("."[0-9]+)?e("+"|"-")[0-9]+
Non_WS [^ \t\n]+ 
WS [ \t\n]+

	int n=0;
	int unknown_n=0;
	float x[max_table_size];
	int i=0;
	float sum=0.0;

%%

{Unsigned_int}    {
            printf( "unsigned integer: %s\n", yytext);
			install_float();
            }

{Signed_int}        {
            printf( "signed int: %s\n", yytext);
			install_float();
            }

{Decimal}        {
            printf( "decimal number: %s\n", yytext);
			install_float();
            }

{Scientific}        {
            printf( "scientific number: %s\n", yytext);
			install_float();
            }

{Non_WS}           {
		printf( "unknown: %s\n", yytext );
		unknown_n++;
		}

{WS}          /*doing nothing*/
%%

install_float()
	{
		if(n<max_table_size)
		{
			x[n]=atof(yytext);
			n++;
		}
		else printf("Error: Max Table Size Exceeded.\n");
	}


main( argc, argv )
int argc;
char **argv;
    {
    ++argv, --argc;  /* skip over program name */
    if ( argc > 0 )
            yyin = fopen( argv[0], "r" );

    else
            yyin = stdin;

    yylex();
    printf("\nTOTAL: %d numbers, %d unknown.\n", n, unknown_n);

    for(i=0;i<n;i++)
	{
		sum+=x[i];
	}
	printf("SUM: %g", sum);
    }